﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Creating Analytics Using Elasticsearch Query</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Creating Analytics Using Elasticsearch Query</h1>
        <p>For Elasticsearch based query to work, you first need to create a Elasticsearch (ES) based SQL query. Once the ES based SQL query is created and run the records are fetched from the SQL database and stored in the Elasticsearch. After the records are available in the ES based database, you can create a control using ES based query. The controls created using ES based query when run search and fetch the data from the already existing ES based data based on the Elasticsearch Indices selected. The ES based query runs on the selected Elasticsearch Indices and displays the data. This is the most powerful of all the analytics configuration since it allows to quickly retrieve data using index. The results generated by this analytic configuration are stored in the Elasticsearch for further reference.</p>
        <h3 id="CreatingAnalyticsUsingElasticsearchQuery-Prerequisites">Prerequisites</h3>
        <p>Ensure that following prerequisites are met before running the ES based query:</p>
        <ul>
            <li>ES based SQL query is already created and run. This will fetch the data from the SQL database and store it in ES. For more information about creating an ES based SQL query, refer the section<MadCap:xref href="#Sample"> Sample Elasticsearch Query JSON:</MadCap:xref>.<br />or</li>
            <li>If you already have data which is available in ES based database, you can reuse and filter that too.</li>
        </ul>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">You can now configure the batch size and the elasticsearch index request size to save the records in elasticsearch while running Analytics Elasticsearch.</p>
        </div>
        <div class="confluence-information-macro confluence-information-macro-information conf-macro output-block">
            <ul>
                <li>The batch size can be configured&#160;by setting the value for&#160;<strong>analyticsindexbatchcount</strong> parameter&#160;from&#160;<strong>externalConfig.properties</strong> file.&#160;The default value is set to 7500 if the configuration is not set by the user.&#160;</li>
                <li>The elasticsearch index request size parameter can be configured from <strong>externalConfig.properties</strong>. The default value is set to 25000000 if the configuration is not set by the user. If your index carries more data you can increase this value.</li>
            </ul>
        </div>
        <p>To create an analytical control using Elasticsearch Query, perform the following steps:</p>
        <ol>
            <li>Go to <strong>Analytics &gt; Analytics Configuration List </strong></li>
            <li>
                <p>Click the Elastic&#160;tab.</p>
            </li>
            <li>Click <strong>Create New Analytics</strong>.</li>
            <li>Select <strong>Using ElasticSearch Query</strong>,&#160;click <strong>Create.</strong></li>
            <li>Enter all the parameters in the table, click <strong>Create</strong>.</li>
            <li>
                <p class="auto-cursor-target">Depending on the ES query, you can select the columns and type of fields to be displayed. Click <strong>Submit</strong>.<br /></p>
                <p>Before creating the analytics control, there is an option to <strong>Preview</strong> the control configuration, towards the end of the <strong>Create New Analytics Configuration </strong>page.</p>
                <p>Note the following points related to <strong>Preview</strong> and <strong>Create</strong> buttons:</p>
                <ul>
                    <li>If the SQL query that you entered in the control configuration, returns more than or equal to ten records, then the analytics preview displays all the ten records. If the query returns less than ten records, the preview displays those many numbers of records.</li>
                    <li>The <strong>Preview</strong> button is enabled before you click the<strong> Create</strong> button. Once the analytics control is created, you cannot view the <strong>Preview</strong> button.</li>
                    <li>The <strong>Preview</strong> button is used to validate the correctness of the query syntax and to display the first 10 rows of the result data. This does not validate columns in the analytics query for the allowed action. An error message is displayed if the query syntax is incorrect. You can view the error details from the log files or by executing the same query directly in the database.</li>
                    <li>The <strong>Create</strong> button must be used as the final step in the creation of the analytics control. This validates the mandatory columns in the analytics query for the allowed action. You will be able to select the visible and filterable columns for the control and submit the control creation only if all validations are complete.</li>
                </ul>
                <p>You can refer following configuration table for details on the necessary fields.</p>
                <h4 id="CreatingAnalyticsUsingElasticsearchQuery-AnalyticsDetailtab">Analytics Detail tab</h4>
                <div class="table-wrap">
                    <table class="TableStyle-Default-Table" style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" cellspacing="0">
                        <col style="width: 17.6479%;" class="TableStyle-Default-Table-Column-Column1" />
                        <col style="width: 82.1686%;" class="TableStyle-Default-Table-Column-Column1" />
                        <thead>
                            <tr class="TableStyle-Default-Table-Head-Header1">
                                <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                                <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Analytics Name<span style="color: rgb(255,0,0);">*</span></p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p style="text-align: left;" class="table-text">Enter the appropriate analytics name. This is a free-text-entry field. The analytics name must be unique and system will not allow you to create multiple analytics with the same name.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Status</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Status of&#160;the selected query. This status can either be active or inactive. Only active ES analytical control can be run to fetch the results.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Elastic Search Indices</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Select the ES index based on which you want to filter the ES based JSON query. Ensure that you have earlier used an ES based SQL query and have fetched the data to Elasticsearch.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Elastic Search Index Type</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">This is auto-populated based on the Elasticsearch Indices selected above.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Elastic Search Query JSON</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <div class="content-wrapper">
                                        <p>Specify the Elasticsearch Query in JSON format based on which you want to filter the results from the ES for the selected Index.</p>
                                        <p>Following is a sample of the ES Query JSON, which will be run for the selected Elasticsearch Index selected above. If you are filtering the ES data based on USERCONTEXT, ensure that you have a column mentioned in the JSON as USERCONTEXT. If you are filtering the ES data based on ORGANIZATIONCONTEXT, ensure that you have a column mentioned in the JSON as ORGANIZATIONCONTEXT.&#160;</p>
                                        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                            <p class="note">The terms&#160;ORGANIZATIONCONTEXT and USERCONTEXT are case sensitive and should be in capital case.</p>
                                        </div>
                                        <div class="confluence-information-macro-body">
                                            <p>As few columns are displayed twice because of the query and option to select the column, following columns have been restricted for ES based query to be passed.&#160;</p>
                                            <ul>
                                                <li>status column</li>
                                                <li>comments column</li>
                                                <li>fulrun column</li>
                                                <li>basecountrun column</li>
                                                <li>updatedate column</li>
                                            </ul>
                                            <p>As a workaround, you can still pass status and column by specifying an alias for above-mentioned columns in the JSON, which will still create and run the control. It will display only 1 column as desired for the above columns.</p>
                                        </div>
                                        <p><a name="Sample"></a>Sample Elasticsearch Query JSON:</p>
                                        <MadCap:codeSnippet>
                                            <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                            <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                                            <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">{
  "query": {
    "bool": {
      "must": [
        {
          "match_all": {}
        }
      ],
      "must_not": [],
      "should": []
    }
  },
  "from": 0,
  "size": 10,
  "sort": [],
  "aggs": {}
}    </MadCap:codeSnippetBody>
                                        </MadCap:codeSnippet>
                                    </div>
                                    <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                        <p class="note">You can also use dynamic attributes (including&#160;run-time dynamic attributes) in the&#160;Elastic Search Query JSON field while creating analytics controls using Using ElasticSearch Query option.</p>
                                    </div>
                                    <div class="confluence-information-macro confluence-information-macro-information conf-macro output-block">
                                        <div class="confluence-information-macro-body">
                                            <p>Here is a sample&#160;Elastisearch Query JSON using dynamic attributes:</p>
                                            <MadCap:codeSnippet>
                                                <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                                <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                                                <MadCap:codeSnippetBody MadCap:useLineNumbers="False" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">{
  "_source": {
    "excludes": [
      "headers",
      "@version",
      "@timestamp",
      "updateDate",
      "analyticsHistoryKey",
      "comments",
      "analyticsConfig",
      "hashCode",
      "fulRun",
      "status"
    ]
  },
  "query": {
    "bool": {
      "must": [
        {
          "term": {
            "analyticsHistoryKey": {
              "value": "19d18237e07144fd997efd0c91d94db4",
              "boost": 1
            }
          }
        },
        {
          "terms": {
            "city.keyword": [
              "goa",
              "gotham",
              "delhi",
              "mysuru",
              "mumbai",
              "mangalore",
              "bangalore",
              "${city_Enum}"
            ],
            "boost": 1
          }
        },
        {
          "terms": {
            "firstName.keyword": [
              "aleksey",
              "christopher",
              "gaurav",
              "michael",
              "${firstname_MultiSelect}"
            ],
            "boost": 1
          }
        },
        {
          "terms": {
            "username.keyword": [
              "aleksey_mikhaylov",
              "man",
              "man001",
              "alekseym",
              "${username_sql}"
            ],
            "boost": 1
          }
        },
        {
          "terms": {
            "status": [
              "0"
            ],
            "boost": 1
          }
        }
      ],
      "adjust_pure_negative": true,
      "boost": 1
    }
  }
}  </MadCap:codeSnippetBody>
                                            </MadCap:codeSnippet>
                                        </div>
                                    </div>
                                    <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                        <p class="note">Column comments, fulRun, status cannot be used.</p>
                                    </div>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Description</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Provide addition details for the analytics ES based query here.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Action</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">If you want to make a report as actionable, you can pre-select the actions that need to be taken on records displayed in the control report. For more information, see&#160;Allowed Actions Table.</p>
                                    <p class="table-text">
                                        <img src="../Resources/Images/Selecting the Action options for an Analytics Report.png" style="border-left-style: solid;border-left-width: 1px;border-right-style: solid;border-right-width: 1px;border-top-style: solid;border-top-width: 1px;border-bottom-style: solid;border-bottom-width: 1px;" />
                                    </p>
                                    <p class="table-text">Figure: Selecting the Action options for an Analytics Report</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Tags</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify the tags using which you want to specify a label for the analytical control. Tags help in searching or filtering the analytical control.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Category</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Category into which the new analytic belongs to:</p>
                                    <p class="table-text"><strong>Access Request System -&#160; </strong>analytic belonging to ARS.</p>
                                    <p class="table-text"><strong>Preventive SOD check - </strong>analytic is for preventive SOD check.</p>
                                    <p class="table-text"><strong>Information Refresh -&#160;</strong>analytic is for looking for stale information or refreshing the information.</p>
                                    <p class="table-text"><strong>Non Person Accounts - </strong>analytic is for checking the non person accounts.</p>
                                    <p class="table-text"><strong>Usage -</strong> analytic is for understanding the usage.</p>
                                    <p class="table-text"><strong>Provisioning - </strong>analytic for keeping track of provisioning.</p>
                                    <p class="table-text"><strong>De Provisioning -&#160;</strong>analytic for keeping track of de-provisioning.</p>
                                    <p class="table-text"><strong>Certification -&#160;</strong>analytic for keeping track of certifications.</p>
                                    <p class="table-text">You can as well create a new category if required.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Sub Category</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Inside a category, you can further divide the analytical controls under sub categories.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Risk</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify the level of risk involved in creating the analytic, possible values are:</p>
                                    <ul>
                                        <li>Low - involves less risk</li>
                                        <li>Medium - involves medium risk</li>
                                        <li>High - involves high risk</li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Recommendations</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Using recommendations you can specify if there is any suggested or recommended actions which should be taken for the respective analytical control.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Number of History to Keep</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <div class="content-wrapper">Enter the number of entries to be stored in the history for analysis in numerical format.<p>For example, If the count is 5, then on 6th run, run history details of the very first run will be deleted from Saviynt Security Manager. <br /></p><p>The 'Number of History to Keep' value should always be greater than the 'Base Count' value.</p></div>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Enable Archival</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Select this option if the number of history to keep is more than 0. If selected, then the&#160;older control result will be archived in the archival folder before deleting it.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Base Count</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Displaying all the records each time continuously, would be an overhead for IGA. Using Base count feature, IGA allows you to specify the count from when the number of records to be displayed is a delta or difference between the number of records available before the run and records newly added after the run.</p>
                                    <p class="table-text">To understand this, lets take an example:</p>
                                    <p class="table-text">Base count is set to 3 for following example use case.</p>
                                    <ul>
                                        <li>First run - &gt; number of records fetched is 10. Hence, base set is set to 10 records.<ul><li>New records are added after first run : 2 records added</li></ul></li>
                                        <li>Second run - &gt; number of records to be shown will be 2, which is delta from current run (12) - previous run base set (10) = 2<ul><li>New records are added after second run : 5 records added</li></ul></li>
                                        <li>Third run - &gt; number of records to be shown will be 5, which is delta from current run (17) - previous run base set (12) = 5</li>
                                        <li>Now, as per the Base Count configured which is 3 in this example, the base set is set to 17 after 3 runs.<ul><li>Before the fourth run, 3 more records are added.</li></ul></li>
                                        <li>Fourth run - &gt; number of records to be shown will be 3, which is delta from current run (20) - previous run base set (17) = 3</li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Context</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Allows you to filter the analytic records based on either user or organization context. An organization is a collection of multiple endpoints. If you want to filter the records for specific organization, you can specify organization ID in the JSON and select context as organization. You should also have a column in JSON data result, as ORGANIZATIONCONTEXT if you are using Organization as the context.</p>
                                    <p class="table-text">If you want to filter the records from ES database based on User, you need to have USERCONTEXT column available in the JSON query result. You can filter user records by selecting Context as User.</p>
                                    <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                        <p class="note">The terms&#160;ORGANIZATIONCONTEXT and USERCONTEXT are case sensitive and should be in capital case.</p>
                                    </div>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                                    <p class="table-text">Email Template</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                                    <p class="table-text">The Email template being used, to send out analytic report to the user.</p>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </li>
            <li>The next screen, provides you the details of analytics for editing. Click <strong>Edit.</strong></li>
            <li>For creating a similar analytic report from an existing Analytic Configuration. Click <strong>Create Similar Analytics</strong></li>
            <li>
                <p>After the analytics is created, you can run the analytic using the following options available under <strong>Run.</strong></p>
                <ol>
                    <li>Dry Run - The newly created/edited analytics will be run on a test basis, but the results are not stored in the run history.</li>
                    <li>Run Now -&#160;The newly created/edited analytics will be run and the results are stored under run history.</li>
                    <li>Run History - Displays the previously run analytics history and results from multiple runs can be compared</li>
                </ol>
            </li>
            <li>The analytics history can be viewed from <strong>History</strong> tab. The History tab displays the log of changes done each time for the analytical control.</li>
            <li>You can also delete an existing analytic from the screen. Click <strong>Delete.</strong></li>
        </ol>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">In&#160;Create New Analytics (v2)&gt; Using Elasticsearch Query&gt; Create New Analytics Configurationpage, you can select multiple indices in the Elastic Search field, which also helps you to&#160;build trends and summary reports.</p>
        </div>
        <p>&#160;</p>
    </body>
</html>